<div class="category-assignment-override">
<p-table #dt [scrollable]="true" [value]="categories" [globalFilterFields]="['name']" styleClass="p-datatable-striped" tableStyleClass="table-with-action-buttons">
    <ng-template pTemplate="caption">
        <div style="text-align:center">Categories</div>
        <!-- <input type="text" pInputText size="50" placeholder="Search"
            (input)="dt.filterGlobal($event.target.value, 'contains')" style="width:100%"> -->
    </ng-template>
    <ng-template pTemplate="header">
        <tr>
            <th class="rowStyle">Name</th>
            <th *ngIf="hasWritePermission" style="width: 37px;">
                <button pButton icon="fa fa-plus" (click)="onAddCategory()"></button>
            </th>
        </tr>
    </ng-template>
    <ng-template pTemplate="body" let-category>
        <tr [pSelectableRow]="true" (click)="showProjectsDialog(category)">
            <td>{{category.name}}</td>
            <td *ngIf="hasWritePermission">
                <div class="d-flex justify-content-between">
                    <button pButton icon="fa fa-pencil" (click)="onEditCategory(category)"></button>
                </div>
            </td>
        </tr>
    </ng-template>
</p-table>

<p-dialog header="Category" [(visible)]="dialogVisible" [responsive]="true" [resizable]="false" showEffect="fade"
    [modal]="true" [style]="{ 'width': '600px' }">
    <form [formGroup]="categoryForm" (ngSubmit)="onSaveCategory()">
    <div class="form-group form-row" style="margin-top: 1rem">
        <div class="col-md-2 col-form-label text-md-right align-self-center">
            Name
        </div>
        <div class="col-10">
            <input formControlName="categoryName" id="categoryName" pInputText [(ngModel)]="editCategory.name" type="text" class="w-100" />
            <div *ngIf="f['categoryName'].touched && f['categoryName'].invalid" class="text-danger">
                <div *ngIf="f['categoryName'].errors && f['categoryName'].errors['required']">Name is required.</div>
                <div *ngIf="f['categoryName'].errors && f['categoryName'].errors['maxlength']">Name must be less than 100 characters long</div>
                <div *ngIf="f['categoryName'].errors && f['categoryName'].errors['canNotContainWhiteSpaces']">Name can not contain whitespaces</div>
            </div>
        </div>
    </div>

    <div class="form-group form-row">
        <div class="col-md-2 col-form-label text-md-right">
            Organization unit
        </div>
        <div class="col-10">
            <p-dropdown 
                [(ngModel)]="editCategory.organizationUnit" 
                [options]="orgUnitDropdownItems"
                [style]="{ 'width': '100%' }" 
                [ngModelOptions]="{standalone: true}"
                appendTo="body" />
        </div>
    </div>

    <div class="form-group form-row">
        <div class="col-12 text-right">
            <button pButton label="Save" [disabled]="categoryForm.invalid" type="submit"></button>
        </div>
    </div>
   </form>
</p-dialog>

<p-dialog header="Category" [(visible)]="projectsDialogVisible" [responsive]="true" showEffect="fade" [resizable]="false"  [modal]="true" [style]="{ 'width': '530px' }" appendTo="body">
    <p-listbox 
        [options]="projects"
        [filter]="false"
        [style]="{ 'width': '100%' }"
        [listStyle]="{ 'height': '548px','max-height': 'none' }"
    >
        <p-header>
            <div>
                <i class="fa fa-tasks"></i>
                Projects
            </div>
        </p-header>

        <ng-template pTemplate="item" let-project>
            <div class="flex-grow-1">
                <div class="col d-flex justify-content-between align-items-center">
                    <div>{{project.label}}</div>
                    <div *ngIf="isEditMode && project.value.id === selectedProject.id; else nonEditMode" 
                        class="d-flex justify-content-between align-items-center">
        
                        <button *ngIf="hasWritePermission" pButton icon="fa fa-check" class="float-right p-button-success mx-2"
                                (click)="editProjectCategory(project.value, false)"></button>
        
                        <button *ngIf="hasWritePermission" pButton icon="fa fa-ban" class="float-right p-button-warning"
                            (click)="cancelEditProjectCategory()"></button>
                    </div>
                    <ng-template #nonEditMode>
                        <div>
                            <button *ngIf="hasWritePermission" pButton icon="fa fa-pencil" class="float-right p-button-warning ml-2"
                                (click)="changeEditMode(project.value)">
                            </button>
                        </div>
                    </ng-template>
                </div>
                <div *ngIf="isEditMode && project.value.id === selectedProject.id" class="mt-2">
                    <app-filter-dropdown
                        appendTo="body"
                        [options]="categoryDropdownItems"
                        [(selectedItem)]="selectedCategoryDropdownItem"
                        [style]="{ 'width': '100%' }"
                    ></app-filter-dropdown>
                </div>
            </div>
        </ng-template>
        <p-footer>
            <div class="d-flex flex-grow-1 justify-content-between">
                <div class="footer-filter-dropdown-content">
                    <app-filter-dropdown
                        appendTo="body"
                        [options]="projectDropdownItems"
                        [(selectedItem)]="selectedProjectDropdownItem"
                        [style]="{ 'width': '100%' }"
                    ></app-filter-dropdown>
                </div>
                <button *ngIf="hasWritePermission" pButton icon="fa fa-plus" (click)="editProjectCategory(selectedProjectDropdownItem, true)" [disabled]="!selectedProjectDropdownItem"></button>
            </div>
        </p-footer>
    </p-listbox>
</p-dialog>
</div>